#include <algorithm>
#include <numeric>  // for std::iota
#include <iostream>
#include <vector>

void print(const auto& container) {
	if (container.empty()) {
		std::cout << "{}\n";
		return;
	}
	char sep = '{';
	for (auto& elem : container) {
		std::cout << sep << ' ' << elem;
		sep = ',';
	}
	std::cout << " }\n";
}

int main() {
	std::vector<int> vec;
	vec.resize(17);

	std::fill(vec.begin(), vec.end(), 42);
	print(vec);

	std::generate(vec.begin(), vec.end(),
		[pow = 1]() mutable {
			int orig = pow;
			pow *= 2;
			return orig;
		});
	print(vec);

	std::iota(vec.begin(), vec.end(), 42);
	print(vec);
}
