#include <algorithm>
#include <iostream>
#include <set>
#include <vector>
#include <map>

void print_pairs(const auto& p_container) {
	for (auto& [fst, snd] : p_container) {
		std::cout << fst << " -> " << snd << '\n';
	}
	std::cout << "-----\n";
}

int main() {
	namespace ranges = std::ranges;

	std::map<char, int> m1 = { { 'a', 7 }, { 'c', 9 }, { 'x', 0 } };
	std::map<char, int> m2 = { { 'b', 1 }, { 'c', 2 }, { 'd', 3 } };

	std::vector<std::tuple<char, int>> res;

	ranges::set_union(m1, m2, std::back_inserter(res));
	print_pairs(res);

	// consider using auto& return type if the keys are large
	auto fst = [](const auto& p) { return p.first; };

	res.clear();
	ranges::set_union(m1, m2, std::back_inserter(res),
	                  {}, fst, fst);
	print_pairs(res);
}
