#include <algorithm>
#include <array>
#include <iostream>
#include <vector>

void print(const auto& container) {
	if (container.empty()) {
		std::cout << "{}\n";
		return;
	}
	char sep = '{';
	for (auto& elem : container) {
		std::cout << sep << ' ' << elem;
		sep = ',';
	}
	std::cout << " }\n";
}

int main() {
	namespace ranges = std::ranges;
	std::array arr{ 17, 42, 1, 3, 3, 7, 0 };
	ranges::sort(arr);
	print(arr);

	std::vector vec{ 17, -42, 1, 3, -3, 7, 0 };
	ranges::sort(vec);
	print(vec);

	ranges::sort(vec, std::greater{});
	print(vec);

	ranges::sort(vec, {},
		[](int num) { return std::abs(num); });
	print(vec);
}
