#include <algorithm>
#include <iostream>
#include <vector>

void print(const auto& container) {
	if (container.empty()) {
		std::cout << "{}\n";
		return;
	}
	char sep = '{';
	for (auto& elem : container) {
		std::cout << sep << ' ' << elem;
		sep = ',';
	}
	std::cout << " }\n";
}

int main() {
	std::vector vec{ 0, 1, 0, 4, 0, 2, 0, 5, 0 };
	print(vec);

	auto it = std::remove(vec.begin(), vec.end(), 0);
	print(vec);

	vec.erase(it, vec.end());
	print(vec);

	vec.erase(std::remove_if(vec.begin(), vec.end(),
	            [](int num) { return num % 2 == 0; }),
	          vec.end());
	print(vec);

	vec = { 0, 0, 0, 1, 1, 2, 4, 5, 5, 0 };
	print(vec);

	vec.erase(std::unique(vec.begin(), vec.end()), vec.end());
	print(vec);

	// C++20
	vec = { 0, 1, 0, 4, 0, 2, 0, 5, 0 };
	print(vec);
	std::erase(vec, 0);
	print(vec);
	std::erase_if(vec, [](int num) { return num % 2 == 0; });
	print(vec);
	// no such convenience wrapper for std::unique :-(
}
