#include <algorithm>
#include <iterator>
#include <iostream>
#include <vector>

void show_range(auto begin, auto end) {
	for (auto it = begin; it != end; ++it) {
		std::cout << *it << ' ';
	}
}

void show_iters(auto begin, auto mid, auto end) {
	show_range(begin, mid);
	std::cout << "| ";
	show_range(mid, end);
	std::cout << '\n';
}

int main() {
	std::vector v{
		3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5, 8, 9, 7, 9 };

	auto iter = std::find(v.begin(), v.end(), 6);
	auto r_iter = std::reverse_iterator{ iter };

	std::cout << *iter << '\n';
	std::cout << *r_iter << '\n';

	show_iters(v.begin(), iter, v.end());
	show_iters(v.rbegin(), r_iter, v.rend());

	std::cout << "---\n";

	std::sort(v.begin(), iter);
	std::sort(v.rbegin(), r_iter);

	show_iters(v.begin(), iter, v.end());
}
