#include <algorithm>
#include <array>
#include <iostream>
#include <vector>

void print(const auto& container) {
	if (container.empty()) {
		std::cout << "{}\n";
		return;
	}
	char sep = '{';
	for (auto& elem : container) {
		std::cout << sep << ' ' << elem;
		sep = ',';
	}
	std::cout << " }\n";
}

int main() {
	std::array arr{ 17, 42, 1, 3, 3, 7, 0 };
	std::sort(arr.begin(), arr.end());
	print(arr);

	std::vector vec1{ 17, 42, 1, 3, 3, 7, 0 };
	std::sort(vec1.begin(), vec1.end());
	print(vec1);

	std::vector vec2{ 17, 42, 1, 3, 3, 7, 0 };
	std::sort(vec2.begin() + 1, vec2.end() - 2);
	print(vec2);

	auto it = std::find(vec2.begin(), vec2.end(), 42);
	std::sort(it, vec2.end());
	print(vec2);

	std::sort(vec2.begin(), it,
	          [](int x, int y) { return y < x; });
	print(vec2);

	std::sort(vec2.begin(), vec2.end(),
	          std::greater{});
	print(vec2);
}
