#include <algorithm>
#include <functional>
#include <iostream>
#include <ranges>
#include <vector>

void print_view(auto view) {
	for (const auto& x : view) {
		std::cout << x << ' ';
	}
	std::cout << '\n';
}

int main() {
	namespace views = std::views;

	auto ten = views::take(views::iota(1), 10);
	print_view(ten);

	print_view(views::iota(1) | views::take(10));
	print_view(views::iota(1) | views::drop(10) | views::take(10));

	std::vector vec = { 1, 3, 5, 7, 0, 2, 4, 6, 8, 10, 11 };
	auto odd = [](int num) { return num % 2 == 1; };

	print_view(vec | views::take_while(odd));
	print_view(vec | views::drop_while(odd));

	auto first_even =
		views::drop_while(odd) | views::take_while(std::not_fn(odd));

	print_view(vec | first_even);
}
