#include <algorithm>
#include <iostream>
#include <ranges>
#include <vector>

int main() {
	namespace views = std::views;
	namespace ranges = std::ranges;

	for (int num : views::iota(1, 7)) {
		std::cout << num << ' ';
	}
	std::cout << '\n';

	for (int num : views::iota(17)) {
		std::cout << num << ' ';
		if (num == 42) break;
	}
	std::cout << '\n';

	std::vector<int> vec;
	ranges::copy(views::iota(1, 11), std::back_inserter(vec));

	for (int num : ranges::subrange(vec.begin() + 2, vec.end() - 3)) {
		std::cout << num << ' ';
	}
	std::cout << '\n';
}
