#include <algorithm>
#include <iostream>
#include <ranges>
#include <vector>

void print_view(auto view) {
	for (const auto& x : view) {
		std::cout << x << ' ';
	}
	std::cout << '\n';
}

int main() {
	namespace views = std::views;

	std::vector vec = { 1, 0, 17, 42, 1337, -1 };

	print_view(vec
		| views::reverse
		| views::transform([](int x) { return 2 * x; })
		| views::filter([](int x) { return x % 3 == 0; })
	);
}
